VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmPicToMap 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Picture to Map"
   ClientHeight    =   3060
   ClientLeft      =   30
   ClientTop       =   300
   ClientWidth     =   4260
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   204
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   284
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkInverted 
      Caption         =   "Inverted pixel check (black = tile, else no tile)"
      Height          =   255
      Left            =   360
      TabIndex        =   6
      Top             =   2280
      Width           =   3495
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2280
      TabIndex        =   5
      Top             =   2640
      Width           =   1455
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   375
      Left            =   360
      TabIndex        =   4
      Top             =   2640
      Width           =   1455
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse"
      Height          =   255
      Left            =   3000
      TabIndex        =   3
      Top             =   195
      Width           =   975
   End
   Begin VB.PictureBox picpic 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3495
      Left            =   3840
      ScaleHeight     =   3495
      ScaleWidth      =   3615
      TabIndex        =   2
      Top             =   1440
      Visible         =   0   'False
      Width           =   3615
   End
   Begin MSComDlg.CommonDialog cd 
      Left            =   3360
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.PictureBox picpreview 
      AutoRedraw      =   -1  'True
      Height          =   1455
      Left            =   240
      ScaleHeight     =   1395
      ScaleWidth      =   3675
      TabIndex        =   0
      Top             =   720
      Width           =   3735
   End
   Begin VB.Label lblname 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   240
      TabIndex        =   1
      Top             =   240
      Width           =   2535
   End
End
Attribute VB_Name = "frmPicToMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'holds the tile that is used, this will be set when the form is loaded
'from the general form
Public TileToUse As Integer

Private Sub cmdBrowse_Click()
'Opens a dialog for selecting a picture (bmp or jpg)

    'dialog settings
    On Error GoTo errh
    cd.DialogTitle = "Open a picture..."
    cd.Filter = "*.bmp;*.jpg|*.bmp;*.jpg"
    cd.ShowOpen

    'update the label with the filename
    lblname.Caption = cd.filetitle
    
    'load the picture in the picturebox and give it the correct size
    picpic.Picture = LoadPicture(cd.filename)
    picpic.AutoSize = True
    picpic.AutoSize = False

    'make sure the picture isn't bigger than 1024 pixels, or it would be bigger
    'than the map itself
    If picpic.Width > 1023 Then
        picpic.Width = 1023
    End If
    
    If picpic.Height > 1023 Then
        picpic.Height = 1023
    End If

    'show the preview
    SetStretchBltMode picpreview.hdc, HALFTONE
    StretchBlt picpreview.hdc, 0, 0, picpreview.Width, picpreview.Height, picpic.hdc, 0, 0, picpic.Width, picpic.Height, vbSrcCopy
    picpreview.refresh
    
    'blt the picture onto the image of the picture box
    BitBlt picpic.hdc, 0, 0, picpic.Width, picpic.Height, picpic.hdc, 0, 0, vbSrcCopy
    picpic.refresh

    'preparations are now ready, enable the go
    cmdGo.Enabled = True

    Exit Sub
errh:
    'pressed cancel in dialog box, do nothing
    If Err = cdlCancel Then
        Exit Sub
    End If
End Sub

Private Sub cmdCancel_Click()
'Cancels the form
    'enable the general form again and unload this form
    frmGeneral.Enabled = True
    Unload Me
End Sub

Private Sub cmdGo_Click()
'Do the diffusion, build the array and pass it to the general form, afterwards unload this form
    ' use error diffusion dithering to convert the image to black and
    ' white, then scan like TTM
    Call FloydSteinberg(picpic)
    
    'now create an array
    Dim pic() As Integer
    ReDim pic(picpic.Width, picpic.Height)
    
    Dim i As Integer
    Dim j As Integer
    
    'check every pixel and see if it's black or not
    For j = 0 To picpic.Height
        For i = 0 To picpic.Width
            Dim c As Long
            c = GetPixel(picpic.hdc, i, j)
            
            'if option inverted is on then switch the statements
            If chkInverted.value = vbChecked Then
                If c = vbBlack Then
                    pic(i, j) = TileToUse
                Else
                    pic(i, j) = 0
                End If
            Else
                If c = vbBlack Then
                    pic(i, j) = 0
                Else
                    pic(i, j) = TileToUse
                End If
            End If
        Next
    Next
    
    'reenable the general form
    'pass the info to the ExecutePicToMap and unload this form
    frmGeneral.Enabled = True
    Call frmGeneral.ExecutePicToMap(pic, picpic.Width, picpic.Height)
    Unload Me
    
End Sub

Private Sub Form_Load()
'Disable the general form and go button
    frmGeneral.Enabled = False
    cmdGo.Enabled = False
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'If we press X, then do cancel
    cmdCancel_Click
End Sub

